routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


//Static CMS Pages Routes
Route::get('/services','StaticPageController@index')->name('services');


Route::get('/',function () { return view('home');});
Route::get('about','AboutController@about')->name('about');
Route::get('about/about-management','AboutController@about_management')->name('about_management');
Route::get('about/about-directors','AboutController@about_directors')->name('about_directors');
Route::get('solutions/digital-banking','SolutionsController@digital_banking')->name('digital_banking');
Route::get('solutions/digital-wallet','SolutionsController@solutions')->name('solutions');
Route::get('solutions/finzo-pay','SolutionsController@finzo_pay')->name('finzo_pay');
//Route::get('services','ServicesController@services')->name('services');
Route::get('contact','ContactController@contact')->name('contact');
Route::post('/insert', 'ContactUSController@insert');

Route::get('/changePassword','Auth\ResetPasswordController@showChangePasswordForm');

Route::post('/changePasswordToken','Auth\ResetPasswordController@resetPasswordWithToken');

Route::post('/changePassword','Auth\ResetPasswordController@changePassword')->name('changePassword');

Route::get('/passwordExpiration','Auth\PasswordExpirationController@showPasswordExpirationForm');
Route::post('/passwordExpiration','Auth\PasswordExpirationController@postPasswordExpiration')->name('passwordExpiration');
Route::get('/cms','Admin\Cms\CmsController@index');

// ADMIN ROUTES
Auth::routes();
Route::prefix('admin')->middleware('auth','checkPermissions')->group(function () {

    Route::get('home', 'Admin\HomeController@index')->name('dashboard');

    // MEDIA MANAGER SECURITY ROUTES
    Route::get('/laravel-filemanager', '\UniSharp\LaravelFilemanager\Controllers\LfmController@show');
    Route::post('/laravel-filemanager/upload', '\UniSharp\LaravelFilemanager\Controllers\UploadController@upload');

    // ROLES ROUTES
    Route::resource('roles', 'Admin\Acl\RolesController');

    Route::resource('offers', 'Admin\Offers\OffersController');

    Route::resource('pages', 'Admin\Cms\PageController');

    // USERS ROUTES
    
    Route::any('permission/user-permission/{id}','Admin\User\UsersController@assignPermission');
    Route::any('users/save','Admin\User\UsersController@storePermission');
    Route::resource('users', 'Admin\User\UsersController');
    // PERMISSION ROUTES
    Route::any('permission/assign-permission','Admin\Acl\PermissionController@assignPermission')->name('view.roles.permission');
    Route::any('permission/save','Admin\Acl\PermissionController@storePermissionRole')->name('assign.roles.permission');
    Route::resource('permissions', 'Admin\Acl\PermissionController');

    // LOGS ROUTES
    Route::resource('logs', 'Admin\Logs\LogsController');

});

app/Offers.php
<?php

namespace Finzo;

use Illuminate\Database\Eloquent\Model;
use Finzo\Files;

class Offers extends Model
{
  protected $fillable = [
    'title',
    'file_id',
    'description',
    'priority',
    'expiry_date'
  ];

  public function file()
{
    return $this->belongsTo(Files::class);
}

}

app/Http/Controllers/Admin/Offers/OffersController.php
<?php

namespace Finzo\Http\Controllers\Admin\Offers;

use Illuminate\Http\Request;
use Finzo\Offers;
use Finzo\Files;
use DB;
use Finzo\Http\Controllers\Controller;

class OffersController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
      $offers = Offers::paginate(2);
      return view('admin.offers.index', compact('offers'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.offers.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

      //Getting File Id using File name from files table
      $file_value = $request->get('file_id');
      $file =DB::table('files')->where('file_name', $file_value)->select('id')->first();
      $file_id = json_decode( json_encode($file), true);

      $request->validate([
        'title'=>'required',
        'description'=> 'required',
        'file_id' => 'required',
        'priority' => 'nullable',
        'expiry_date' => 'required',
      ]);
      $offer = new Offers([
        'title' => $request->get('title'),
        'description'=> $request->get('description'),
        'file_id'=> $file_id['id'],
        'priority'=> 1,
        'expiry_date'=> $request->get('expiry_date')
      ]);
      $offer->save();
      return redirect('admin/offers')->with('success', 'Offers has been added');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    public function edit(Offers $offer)
    {   
        return view('admin.offers.edit',compact('offer'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id, Files $file)
    {
        //Getting File Id using File name from files table
        $file_value = $request->get('file_id');
        $file =DB::table('files')->where('file_name', $file_value)->select('id')->first();
        $file_id = json_decode( json_encode($file), true);

        $request->validate([
        'title'=>'required',
        'description'=> 'required',
        'file_id' => 'required',
        'priority' => 'nullable',
        'expiry_date' => 'required'
      ]);


      $offer = Offers::find($id);
      $offer->title = $request->get('title');
      $offer->description = $request->get('description');
      $offer->file_id = $file_id['id'];
      $offer->priority = $request->get('priority');
      $offer->expiry_date = $request->get('expiry_date');
      $offer->save();

      return redirect('admin/offers')->with('success', 'Offers has been updated');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $offer = Offers::find($id);
        $offer->delete();
        return redirect('admin/offers')->with('success', 'Offers has been deleted Successfully');
    }
}

app/Http/Controllers/OffersController.php
<?php

namespace Finzo\Http\Controllers;

use Illuminate\Http\Request;
use Finzo\Offers;
use Finzo\Files;
use DB;

class OffersController extends Controller
{

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
      $offers = Offers::paginate(2);
      return view('admin.offers.index', compact('offers'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.offers.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

      //Getting File Id using File name from files table
      $file_value = $request->get('file_id');
      $file =DB::table('files')->where('file_name', $file_value)->select('id')->first();
      $file_id = json_decode( json_encode($file), true);

      $request->validate([
        'title'=>'required',
        'description'=> 'required',
        'file_id' => 'required',
        'priority' => 'nullable',
        'expiry_date' => 'required',
      ]);
      $offer = new Offers([
        'title' => $request->get('title'),
        'description'=> $request->get('description'),
        'file_id'=> $file_id['id'],
        'priority'=> 1,
        'expiry_date'=> $request->get('expiry_date')
      ]);
      $offer->save();
      return redirect('admin/offers')->with('success', 'Offers has been added');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    public function edit(Offers $offer)
    {   
        return view('admin.offers.edit',compact('offer'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id, Files $file)
    {
        //Getting File Id using File name from files table
        $file_value = $request->get('file_id');
        $file =DB::table('files')->where('file_name', $file_value)->select('id')->first();
        $file_id = json_decode( json_encode($file), true);

        $request->validate([
        'title'=>'required',
        'description'=> 'required',
        'file_id' => 'required',
        'priority' => 'nullable',
        'expiry_date' => 'required'
      ]);


      $offer = Offers::find($id);
      $offer->title = $request->get('title');
      $offer->description = $request->get('description');
      $offer->file_id = $file_id['id'];
      $offer->priority = $request->get('priority');
      $offer->expiry_date = $request->get('expiry_date');
      $offer->save();

      return redirect('admin/offers')->with('success', 'Offers has been updated');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $offer = Offers::find($id);
        $offer->delete();
        return redirect('admin/offers')->with('success', 'Offers has been deleted Successfully');
    }
}

resources/views/admin/offers/create.blade.php
@extends('admin.app')
@section('content')
<div class="row">
    <div class=" col-md-12">
        <div class="card card-shadow mb-4">
            <div class="card-header">
                <div class="card-title">
                    Add Offers
                </div>
            </div>
  <div class="card-body">
    @if ($errors->any())
      <div class="alert alert-danger">
        <ul>
            @foreach ($errors->all() as $error)
              <li>{{ $error }}</li>
            @endforeach
        </ul>
      </div><br />
    @endif
      <form method="post" action="{{ route('offers.store') }}" class="right-text-label-form" >
        @csrf
       <div class="form-group row {{ $errors->has('title') ? 'has-danger' : '' }}">
          <label for="title" class="col-sm-4 col-form-label">Title</label>
          <div class="col-sm-5">
              <input type="text" class="form-control {{ $errors->has('title') ? 'has-input' : '' }}" name="title" id="title" placeholder="Title" value="{{old('title')}}">
              @if ($errors->has('title'))
                  <small class="form-text">
                      <strong>{{ $errors->first('title') }}</strong>
                  </small>
              @endif
          </div>
        </div>

        <div class="form-group row {{ $errors->has('description') ? 'has-danger' : '' }}">
            <label for="title" class="col-sm-4 col-form-label">Description</label>
            <div class="col-sm-5">
                <textarea type="text" class="form-control {{ $errors->has('description') ? 'has-input' : '' }}" name="description" id="description" placeholder="Description" value="{{old('description')}}" rows="3"></textarea>
                @if ($errors->has('description'))
                    <small class="form-text">
                        <strong>{{ $errors->first('description') }}</strong>
                    </small>
                @endif
            </div>
        </div>

        <div class="form-group row {{ $errors->has('file_id') ? 'has-danger' : '' }}">
          <label for="title" class="col-sm-4 col-form-label">Select Image</label>
          <div class="col-sm-5">  
            <div class="input-group">
              <span class="input-group-btn">
                <a id="lfm" data-input="file_id" data-preview="holder2" class="btn btn-info btn-lg text-white">
                  <i class="fa fa-picture-o"></i> Choose
                </a>
              </span>
            <input id="file_id" class="form-control" type="text" name="file_id">
            </div>
            <div id="holder2" style="margin-top:15px;max-height:100px;"></div>
              @if ($errors->has('file_id'))
                  <small class="form-text">
                      <strong>{{ $errors->first('file_id') }}</strong>
                  </small>
              @endif
          </div>
        </div>

        <div class="form-group row {{ $errors->has('expiry_date') ? 'has-danger' : '' }}">
            <label for="title" class="col-sm-4 col-form-label">Expiry Date</label>
            <div class="col-sm-5">
                <input type="text" class="expiry_date form-control {{ $errors->has('expiry_date') ? 'has-input' : '' }}" name="expiry_date" id="expiry_date" placeholder="Expiry Date" value="{{old('expiry_date')}}">
                @if ($errors->has('expiry_date'))
                    <small class="form-text">
                        <strong>{{ $errors->first('expiry_date') }}</strong>
                    </small>
                @endif
            </div>
        </div>

        <div class="form-group row">
          <div class="col-sm-8 ml-auto">
              <button type="submit" class="btn btn-success">
                  Create Offer
              </button>
          </div>
        </div>
      </form>
  </div>
</div>
</div>
</div>

<script src="https://code.jquery.com/jquery-3.2.1.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.3/umd/popper.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-beta.2/js/bootstrap.min.js"></script>
  <script>
   var route_prefix = "{{ url(config('lfm.url_prefix')) }}";
  </script>

  <script>
    {!! \File::get(base_path('vendor/unisharp/laravel-filemanager/public/js/stand-alone-button.js')) !!}
  </script>
  <script>
    $('#lfm').filemanager('', {prefix: route_prefix});
  </script>


  <style>
    .popover {
      top: auto;
      left: auto;
    }
  </style>
@endsection

resources/views/admin/offers/edit.blade.php
@extends('admin.app')
@section('content')
<div class="row">
    <div class=" col-md-12">
        <div class="card card-shadow mb-4">
            <div class="card-header">
                <div class="card-title">
                    Edit Offers
                </div>
            </div>
  <div class="card-body">
    @if ($errors->any())
      <div class="alert alert-danger">
        <ul>
            @foreach ($errors->all() as $error)
              <li>{{ $error }}</li>
            @endforeach
        </ul>
      </div><br />
    @endif


      <form action="{{ route('offers.update',$offer->id) }}" class="right-text-label-form" method="POST" enctype="multipart/form-data">
        @csrf
        @method('PATCH')
        
        <div class="form-group row {{ $errors->has('title') ? 'has-danger' : '' }}">
          <label for="title" class="col-sm-4 col-form-label">Title</label>
          <div class="col-sm-5">
              <input type="text" class="form-control {{ $errors->has('title') ? 'has-input' : '' }}" name="title" id="title" placeholder="Title" value="{{old('title', $offer->title)}}">
              @if ($errors->has('title'))
                  <small class="form-text">
                      <strong>{{ $errors->first('title') }}</strong>
                  </small>
              @endif
          </div>
        </div>

        <div class="form-group row {{ $errors->has('description') ? 'has-danger' : '' }}">
            <label for="title" class="col-sm-4 col-form-label">Description</label>
            <div class="col-sm-5">
                <textarea type="text" class="form-control {{ $errors->has('description') ? 'has-input' : '' }}" name="description" id="description" value="{{ $offer->description }}" rows="3">{{ $offer->description }}</textarea>
                @if ($errors->has('description'))
                    <small class="form-text">
                        <strong>{{ $errors->first('description') }}</strong>
                    </small>
                @endif
            </div>
        </div>

        <div class="form-group row {{ $errors->has('file_id') ? 'has-danger' : '' }}">
          <label for="title" class="col-sm-4 col-form-label">Select Image</label>
          <div class="col-sm-5">  
            <div class="input-group">
              <span class="input-group-btn">
                <a id="lfm" data-input="file_id" data-preview="holder2" class="btn btn-info btn-lg text-white">
                  <i class="fa fa-picture-o"></i> Choose
                </a>
              </span>
            <input id="file_id" value="{{$offer->file->file_name}}" class="form-control" type="text" name="file_id">
            </div>
            <div id="holder2" style="margin-top:15px;max-height:100px;"></div>
              @if ($errors->has('file_id'))
                  <small class="form-text">
                      <strong>{{ $errors->first('file_id') }}</strong>
                  </small>
              @endif
          </div>
        </div>

        <div class="form-group row {{ $errors->has('expiry_date') ? 'has-danger' : '' }}">
          <label for="title" class="col-sm-4 col-form-label">Expiry Date</label>
          <div class="col-sm-5">
            <input type="text" class="expiry_date form-control {{ $errors->has('expiry_date') ? 'has-input' : '' }}" name="expiry_date" id="expiry_date" placeholder="Expiry Date" value="{{ $offer->expiry_date }}">
            @if ($errors->has('expiry_date'))
                <small class="form-text">
                    <strong>{{ $errors->first('expiry_date') }}</strong>
                </small>
            @endif
          </div>
        </div>

        <div class="form-group row">
          <div class="col-sm-8 ml-auto">
              <button type="submit" class="btn btn-success">
                  Update Offers
              </button>
          </div>
        </div>
      </form>
  </div>
</div>

<script src="https://code.jquery.com/jquery-3.2.1.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.3/umd/popper.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-beta.2/js/bootstrap.min.js"></script>
  <script>
   var route_prefix = "{{ url(config('lfm.url_prefix')) }}";
  </script>

  <script>
    {!! \File::get(base_path('vendor/unisharp/laravel-filemanager/public/js/stand-alone-button.js')) !!}
  </script>
  <script>
    $('#lfm').filemanager('', {prefix: route_prefix});
  </script>

  <style>
    .popover {
      top: auto;
      left: auto;
    }
  </style>
@endsection

resources/views/admin/offers/index.blade.php
@extends('admin.app')
@section('content')

<div class="row">
   <div class=" col-xl-12">
      <div class="card card-shadow mb-4">
        <div class="card-header">
          <div class="card-title">
            <div class="row">
              <div class="col-sm-12 col-md-6">Offers List</div>
			  	@can('offers.create')
                <div class="col-sm-12 col-md-6 text-right">
                  <a href="/admin/offers/create" class="btn btn-info">Add Offers</a>
                </div>
				@endcan
             </div>
            </div>
         </div>
    
	<div class="card-body">
		  @if(session()->get('success'))
    		<div class="alert alert-success">
      		{{ session()->get('success') }}  
    		</div><br />
  		@endif
		<table class="table">
			<thead>
				<tr>
					<th scope="col">#ID</th>
					<th scope="col">Image</th>
					<th scope="col">Title</th>
					<th scope="col">Expiry Date</th>
					@if(Auth::user()->hasAnyPermission(['offers.create', 'offers.destroy']))
					<th scope="col">Actions</th>	
					@endcan				
				</tr>
			</thead>
			<tbody>
				@foreach($offers as $offer)
				<tr>
					<th scope="row">{{$offer->id}}</th>
					<td><img src="{{$offer->file->file_path}}" height="50px" width="50px" /></td>
					<td>{{$offer->title}}</td>
					<td>{{$offer->expiry_date}}</td>
					<td>
					@can('pages.edit')
					<a href="{{ route('offers.edit',$offer->id)}}" class="btn btn-square btn-dark btn-sm"><i class="icon-note "></i></a>					
					@endcan
					@can('pages.destroy')
						<form action="{{ route('offers.destroy', $offer->id)}}" method="post">
			              @csrf
			              @method('DELETE')
			              <button class="btn btn-square btn-secondary btn-sm" type="submit"><i class="icon-trash "></i></button>
			            </form>
					@endcan
					</td>
				</tr>
				 @endforeach
          @if(count($offers) == 0)
          <tr>
              <td colspan="5">
              {{"No Offers Found"}}
              </td>
          </tr>
          @endif
			</tbody>	
		</table>	
		<div class="row">
			<div class="col-sm-12 col-md-5">
				<div class="dataTables_info" id="bs4-table_info" role="status" aria-live="polite">Showing 1 to 10 of {{ $offers->total() }} entries
				</div>
			</div>
			<div class="col-sm-12 col-md-7">
			<div class="dataTables_paginate paging_simple_numbers" id="bs4-table_paginate">
				<!--Pagination-->
				{{ $offers->links() }}
			</div>
		</div>
	</div>

	</div>
</div>
</div>
</div>
@endsection